//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "GetRGBHistogram0.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void toGray(TImage *image)
{ Byte * ptr;
  int r, g, b, gray, index;

  image->Picture->Bitmap->PixelFormat = pf24bit;
  for (int row=0; row<image->Picture->Height; row++)
     { ptr = (Byte*) image->Picture->Bitmap->ScanLine[row];
       index = 0;
       for (int col=0; col<image->Picture->Width; col++)
          { b = ptr[index  ];
            g = ptr[index+1];
            r = ptr[index+2];
            gray = 0.299*r + 0.587*g + 0.114*b;
            ptr[index  ] = (Byte)gray;
            ptr[index+1] = (Byte)gray;
            ptr[index+2] = (Byte)gray;
            index += 3;
          }
     }
}
void toGray2D(TImage *image)
{ Byte **ptr;
  int r, g, b, gray, index;

  image->Picture->Bitmap->PixelFormat = pf24bit;
  ptr = new Byte*[image->Picture->Height];
  for (int k=0; k<image->Picture->Height; k++)
     ptr[k] = (Byte*) image->Picture->Bitmap->ScanLine[k];
  for (int row=0; row<image->Picture->Height; row++)
     { index = 0;
       for (int col=0; col<image->Picture->Width; col++)
          { b = ptr[row][index  ];
            g = ptr[row][index+1];
            r = ptr[row][index+2];
            gray = 0.299*r + 0.587*g + 0.114*b;
            ptr[row][index  ] = (Byte)gray;
            ptr[row][index+1] = (Byte)gray;
            ptr[row][index+2] = (Byte)gray;
            index += 3;
          }
     }
  delete [] ptr;
}
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Form1->DoubleBuffered = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Load1Click(TObject *Sender)
{
  if ( OpenDialog1->Execute() )
    { Image1->Picture->LoadFromFile(OpenDialog1->FileName);
      Image1->Top  = 1;
      Image1->Left = 1;
      Graphics::TBitmap *bmp = new Graphics::TBitmap();
      bmp->Width  = Image1->Picture->Width;
      bmp->Height = Image1->Picture->Height;
      bmp->Canvas->Draw(0,0,Image1->Picture->Graphic);
      Image1->Picture->Bitmap->Assign(bmp);
      Image1->Refresh();
      delete bmp;
    }
}
//---------------------------------------------------------------------------
void JpgToBmp(TImage *image)
{ Graphics::TBitmap *bmp = new Graphics::TBitmap();

  bmp->Width  = image->Picture->Width;
  bmp->Height = image->Picture->Height;
  bmp->Canvas->Draw(0,0,image->Picture->Graphic);
  image->Picture->Bitmap->Assign(bmp);
  image->Refresh();

  delete bmp;
}

void showRGBHistogram(TImage *image, TCanvas *canvas)
{ Byte * ptr;
  int rgb[3][256]={0}, max[3]={0}, r, g, b, gray, index;

  image->Picture->Bitmap->PixelFormat = pf24bit;
  for (int row=0; row<image->Picture->Height; row++)
     { ptr = (Byte*) image->Picture->Bitmap->ScanLine[row];
       index = 0;
       for (int col=0; col<image->Picture->Width; col++)
          { b = ptr[index  ];
            g = ptr[index+1];
            r = ptr[index+2];
            rgb[0][b]++;
            rgb[1][g]++;
            rgb[2][r]++;
            index += 3;
          }
     }
  for (int x=0; x<256; x++)
     { for (int p=0; p<3; p++)
          { if ( rgb[p][x]>max[p] )
               max[p] = rgb[p][x];
          }
     }
  TColor colors[3] = {clRed, clGreen, clBlue};
  for (int p=0; p<3; p++)
     { float scale = (float)256 / max[p];

       canvas->Pen->Color = colors[p];
       canvas->MoveTo(0, (int)(256-rgb[p][0]*scale));
       for (int x=1; x<256; x++)
          { canvas->LineTo(x, (int)(256-rgb[p][x]*scale));
          }
     }
}


void __fastcall TForm1::Button1Click(TObject *Sender)
{
  JpgToBmp(Image1);
  toGray2D(Image1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  JpgToBmp(Image1);
  showRGBHistogram(Image1, Image2->Canvas);
}
//---------------------------------------------------------------------------

